/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import { defineComponent as l, inject as c, createVNode as s, h as p } from "vue";
import { noop as m, getTemplate as b } from "@progress/kendo-vue-common";
import { KEYBOARD_NAV_DATA_LEVEL as u, KEYBOARD_NAV_DATA_ID as I } from "@progress/kendo-vue-data-tools";
const x = /* @__PURE__ */ l({
  props: {
    colSpan: Number,
    ariaColIndex: Number,
    dataItem: [Object, String, Number],
    dataIndex: Number,
    detail: [String, Function, Object],
    id: String
  },
  inject: {
    getKeyboardNavigationAttributes: {
      default: m
    }
  },
  setup() {
    return {
      kendoIntlService: c("kendoIntlService", {})
    };
  },
  render() {
    const {
      colSpan: e,
      ariaColIndex: a,
      dataItem: n,
      dataIndex: r,
      id: i
    } = this.$props, t = this.getKeyboardNavigationAttributes(i), d = function(o) {
      return b.call(this, {
        h: p,
        template: this.$props.detail,
        additionalProps: o
      });
    };
    return s("td", {
      class: "k-table-td k-detail-cell",
      colspan: e,
      "aria-colindex": a,
      role: "gridcell",
      tabindex: t.tabIndex,
      "data-keyboardnavlevel": t[u],
      "data-keyboardnavid": t[I]
    }, [d.call(this, {
      dataItem: n,
      dataIndex: r
    })]);
  }
});
export {
  x as GridDetailCell
};
