/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import { defineComponent as t, inject as r, createVNode as n } from "vue";
import { KEYBOARD_NAV_DATA_LEVEL as i, KEYBOARD_NAV_DATA_ID as o } from "@progress/kendo-vue-data-tools";
import { noop as a } from "@progress/kendo-vue-common";
const s = /* @__PURE__ */ t({
  props: {
    id: String
  },
  inject: {
    getKeyboardNavigationAttributes: {
      default: a
    }
  },
  setup() {
    return {
      kendoIntlService: r("kendoIntlService", {})
    };
  },
  render() {
    const e = this.getKeyboardNavigationAttributes(this.$props.id);
    return n("td", {
      class: "k-table-td k-hierarchy-cell",
      tabindex: e.tabIndex,
      "data-keyboardnavlevel": e[i],
      "data-keyboardnavid": e[o]
    }, null);
  }
});
export {
  s as GridDetailHierarchyCell
};
