/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import { defineComponent as o, createVNode as n, h as s } from "vue";
import { GridColumnMenuSort as r } from "./GridColumnMenuSort.mjs";
import { GridColumnMenuFilter as i } from "./GridColumnMenuFilter.mjs";
import { Keys as l, getTemplate as a } from "@progress/kendo-vue-common";
const m = /* @__PURE__ */ o({
  name: "KendoColumnMenuContent",
  inheritAttrs: !1,
  props: {
    column: Object,
    sortable: [Boolean, Object],
    sort: {
      type: Array
    },
    filter: Object,
    filterOperators: Object,
    filterable: Boolean,
    render: [Boolean, String, Function, Object],
    onContentfocus: Function,
    onClosemenu: Function,
    onSortchange: Function,
    onExpandchange: Function,
    onFilterchange: Function
  },
  methods: {
    handleFocus(e) {
      this.$emit("contentfocus", e);
    },
    closeMenu() {
      this.$emit("closemenu");
    },
    expandChange() {
      this.$emit("expandchange");
    },
    sortChange(e, t) {
      this.$emit("sortchange", e, t);
    },
    filterChange(e, t) {
      this.$emit("filterchange", e, t);
    },
    contentKeyDown(e) {
      e.keyCode === l.esc && this.$emit("closemenu");
    }
  },
  render() {
    const e = this.$props.render, t = n("div", {
      style: this.$attrs.style,
      onKeydown: this.contentKeyDown
    }, [n(r, {
      column: this.$props.column,
      sortable: this.$props.sortable,
      sort: this.$props.sort,
      onClosemenu: this.closeMenu,
      onSortchange: this.sortChange
    }, null), n(i, {
      column: this.$props.column,
      filterable: this.$props.filterable,
      filter: this.$props.filter,
      filterOperators: this.$props.filterOperators,
      onFilterfocus: this.handleFocus,
      onClosemenu: this.closeMenu,
      onExpandchange: this.expandChange,
      onFilterchange: this.filterChange
    }, null)]);
    return a.call(this, {
      h: s,
      template: typeof e != "boolean" && e,
      defaultRendering: t,
      additionalProps: this.$props,
      additionalListeners: {
        closemenu: this.closeMenu,
        filterchange: this.filterChange,
        sortchange: this.sortChange,
        expandchange: this.expandChange,
        contentfocus: this.handleFocus
      }
    });
  }
});
export {
  m as ColumnMenuContent
};
