/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const r=require("vue"),o=require("@progress/kendo-vue-common"),g=require("@progress/kendo-vue-data-tools"),fe=require("@progress/kendo-vue-indicators"),Y=require("./GridNav.js"),me=require("./cells/GridSelectionCell.js"),be=require("./cells/GridHierarchyCell.js"),Ce=require("./cells/GridDetailHierarchyCell.js"),$e=require("./cells/GridDetailCell.js"),ve=require("./cells/GridEditCell.js"),Ie=require("./header/Header.js"),Re=require("./header/HeaderRow.js"),we=require("./header/FilterRow.js"),ye=require("./header/GroupPanel.js"),ke=require("./footer/Footer.js"),He=require("./footer/FooterRow.js"),Z=require("./filterCommon.js"),q=require("./VirtualScroll.js"),ee=require("./VirtualScrollFixed.js"),Se=require("./drag/ColumnResize.js"),xe=require("./drag/CommonDragLogic.js"),Ne=require("./drag/DragClue.js"),Ve=require("./drag/DropClue.js"),b=require("./utils/main.js"),Ge=require("./cells/GridCell.js"),te=require("./cells/GridGroupCell.js"),Fe=require("./rows/GridRow.js"),_e=require("./header/GridHeaderSelectionCell.js"),Te=require("./GridNoRecords.js"),se=require("./package-metadata.js"),ie=require("./messages/main.js"),ze=r.defineComponent({name:"KendoGrid",props:{topCacheCount:{type:Number,default:0},collapsedGroups:{type:Array,default:function(){return[]}},uniqueField:String,totalGroupedHeight:Number,allGroupedItems:Object,alternatePerGroup:Boolean,columns:Array,columnVirtualization:Boolean,dataItems:[Array,Object],sortable:[Boolean,Object],sort:Array,filterable:Boolean,filterOperators:Object,filterCellRender:[String,Function,Object],headerCellRender:[String,Function,Object],loader:[String,Function,Object,Boolean],filter:Object,pageable:[Boolean,Object],pageSize:Number,total:Number,skip:Number,take:Number,expandField:String,expandColumn:Object,selectedField:String,cellRender:[String,Function,Object],rowRender:[String,Function,Object],resizable:Boolean,reorderable:Boolean,group:Array,groupable:[Boolean,Object],editField:String,rowClass:Function,scrollable:{type:String,default:"scrollable"},size:{type:String,default:"medium",validator:function(e){return["small","medium"].includes(e)}},pager:[String,Function,Object],rowHeight:Number,detailRowHeight:Number,detail:[String,Function,Object],columnMenu:[Boolean,String,Function,Object],columnMenuAnimate:{type:[Boolean,Object],default:function(){return!0}},columnMenuIcon:o.SvgIcon,dataItemKey:String,navigatable:{type:Boolean,default:!1},onItemchange:Function,onExpandchange:Function,onDatastatechange:Function,onPagechange:Function,onSortchange:Function,onFilterchange:Function,onGroupchange:Function},data(){return{isRtl:!1,context:void 0,navigation:void 0,showLicenseWatermark:!1,notHiddenColumns:[]}},watch:{skip:function(e,t){this.onSkipChanged(e,t)},total:function(e,t){this.onTotalChanged(e,t)},rowHeight:function(e,t){this.onRowHeightChanged(e,t)}},created(){o.validatePackage(se.packageMetadata),this.showLicenseWatermark=o.shouldShowValidationUI(se.packageMetadata),this.initialHeight=null,this._columns=[];const e=this.currentGroupable,t=this.getVirtualScroll();this.vs=new t(e||this.$props.rowHeight===void 0||this.$props.rowHeight===0,this.$props.topCacheCount),this.dragLogic=new xe.CommonDragLogic(this.columnReorder.bind(this),this.groupReorder.bind(this),this.columnToGroup.bind(this)),this.columnResize=new Se.ColumnResize(this.onResize.bind(this)),this._columnsMap=[[]],this._header=null,this._footer=null,this.forceUpdateTimeout=void 0,this._gridId=o.guid(),this._gridRoleElementId=o.guid(),this.slicedCurrentData=void 0,this._prevTotal=void 0},mounted(){this.setRefs();const e=o.isRtl(this._element);this._prevTotal=this.$props.total,this.isRtl=e,this.initialHeight=this._element.style?this._element.style.height:null,this.resizeObserver=o.canUseDOM&&window.ResizeObserver&&new ResizeObserver(this.calculateMedia),document!=null&&document.body&&this.resizeObserver&&this.resizeObserver.observe(document.body)},updated(){this.setRefs();const e=o.isRtl(this._element);this.isRtl=e,this._prevTotal=this.$props.total,this.vs.tableTransform&&this.vs.table&&(this.vs.table.style.transform=this.vs.tableTransform,this.vs.tableTransform="")},unmounted(){this.gridUnmounted()},computed:{nonscrollableWrapperClass(){const{size:e}=this.$props;return{"k-grid":!0,"k-grid-md":!e,[`k-grid-${o.kendoThemeMaps.sizeMap[e]||e}`]:e}},scrollableWrapperClass(){const{scrollable:e}=this.$props;return{...this.nonscrollableWrapperClass,"k-grid-virtual":e==="virtual"}},gridTableClass(){const{size:e}=this.$props;return{"k-table":!0,"k-grid-table":!0,"k-grid-md":!e,[`k-table-${o.kendoThemeMaps.sizeMap[e]||e}`]:e}},getCorrectHeight(){return this.$props.scrollable==="virtual"?this.initialHeight||"450px":null},currentGroupable(){return this.$props.groupable===!0&&this.$props.group&&this.$props.group.length||o.isObject(this.$props.groupable)&&this.$props.groupable.enabled!==!1},computedCollapsed(){let e=[];if(this.$props.group)for(let t=0;t<this.$props.group.length;t++)this.$props.collapsedGroups[t]?e.push(this.$props.collapsedGroups[t]):e.push([]);return e},getAriaRowCount(){const e=this.$props.dataItems,t=this.$props.total!==void 0&&this.$props.total||e!=null&&e.total!==void 0&&e.total||e!=null&&e.length!==void 0&&e.length||0;return this.$props.detail?this._columnsMap.length+(this.$props.filterable?1:0)+t*2+(this._columns.some(i=>!!i.footerCell)?1:0):!this.$props.pageable&&this.$props.scrollable==="scrollable"?void 0:this.$props.groupable?-1:this._columnsMap.length+(this.$props.filterable?1:0)+t+(this._columns.some(i=>!!i.footerCell)?1:0)},getAriaColCount(){const e=this.$props.columns,t=this.$props.columnVirtualization,i=e&&e.filter(a=>a.hidden!==void 0).length!==0;if(t||i)return e.length!==0?e.length:-1}},methods:{getColumnsEssentialProps(e){return e&&JSON.stringify(e.map(t=>({id:t.id,field:t.field,title:t.title,children:t.children})))},calculateMedia(){const e=this.filterHiddenColumns(this.$props.columns||[]);this.getColumnsEssentialProps(this.notHiddenColumns)!==this.getColumnsEssentialProps(e)&&this.$forceUpdate()},filterHiddenColumns(e){if(!e||e.length===0)return e;const t=i=>({...i,children:i.children&&i.children.length>0?this.filterHiddenColumns(i.children):i.children});return[...e].filter(i=>!i.hidden).filter(i=>o.canUseDOM&&i&&i.media?window.matchMedia(i.media).matches:i).map(i=>t(i))},getColumns(){const e=this._columns.filter(i=>i.declarationIndex>=0&&i.parentIndex===-1),t=i=>(i.sort((a,l)=>a.declarationIndex-l.declarationIndex),i.map(a=>{const{declarationIndex:l,parentIndex:d,depth:f,colSpan:p,rowSpan:C,index:w,kFirst:y,children:k,...H}=a;return k.length?{children:t(k),...H}:H}));return t(e)},setRefs(){let e="$el";const t=o.getRef(this,"gridNav");t&&(this._element=t[e]);const i=o.getRef(this,"groupPanelDiv");if(i){let d=i[e]||null;this.dragLogic.refGroupPanelDiv(d)}const a=o.getRef(this,"dropElementClue"),l=o.getRef(this,"dragElementClue");this.dragLogic.refDropElementClue(a),this.dragLogic.refDragElementClue(l),this.columnResize.colGroupMain=o.getRef(this,"colGroup"),this._header=o.getRef(this,"header"),this._footer=o.getRef(this,"footer"),this.vs.containerRef=o.getRef(this,"scrollContainer"),this.vs.table=o.getRef(this,"scrollTable"),this.resetTableWidth(),this.vs.tableBodyRef=o.getRef(this,"scrollTableBody")},gridUnmounted(){clearTimeout(this.forceUpdateTimeout),this.columnResize.columns=[],this.dragLogic.columns=[],this.dragLogic&&this.dragLogic.dragElementClue&&(this.dragLogic.dragElementClue.$el.remove(),this.dragLogic.dropElementClue.$el.remove()),this.currentData=[],this._columns=[],document!=null&&document.body&&this.resizeObserver&&this.resizeObserver.disconnect()},resetVirtual(){this.vs.PageChange=this.pageChangeHandler,this.vs.realSkip=this.$props.skip||0,this.vs.pageSize=(this.$props.take!==void 0?this.$props.take:this.$props.pageSize)||0,this.vs.scrollableVirtual=this.$props.scrollable==="virtual",this.vs.propsSkip=(this.$props.skip||0)+(this.$props.scrollable==="virtual"?this.vs.topCacheCount+(this.vs.attendedSkip-(this.$props.skip||0)):0)},getVirtualScroll(){return q.VirtualScroll},isAllData(){const{dataItems:e,total:t}=this.$props;return Array.isArray(e)?e.length===t:e?t===e.total:!1},initializeVirtualization(e){if((this.$props.total!==this._prevTotal||this.$props.scrollable==="virtual"!==this.vs.scrollableVirtual)&&this.vs.reset(),this.resetVirtual(),this.vs.total=e,this.$props.rowHeight!==void 0&&this.$props.rowHeight>0&&!this.currentGroupable)this.vs.containerHeight=Math.min(1533915,this.$props.rowHeight*(e||0));else if(this.$props.totalGroupedHeight)this.vs.containerHeight=Math.min(1533915,this.$props.totalGroupedHeight);else if(this.$props.allGroupedItems&&this.$props.allGroupedItems.data){const t=this.totalGroupedRows(b.applyExpandedState(this.$props.allGroupedItems,this.computedCollapsed,this.$props.uniqueField).data);this.vs.containerHeight=Math.min(1533915,this.$props.rowHeight*t)}else this.vs.containerHeight=1533915;if(this.slicedCurrentData=void 0,this.vs instanceof ee.VirtualScrollFixed){const{rowHeight:t=0,detail:i,expandField:a}=this.$props;let{detailRowHeight:l=0}=this.$props;l=i&&a?l:t,this.isAllData()?(this.vs.total=this.currentData.length,this.slicedCurrentData=this.currentData.slice(this.vs.realSkip,this.vs.realSkip+this.vs.pageSize),this.vs.rowHeightService=this.rowHeightService(this.vs,this.currentData.length,t,l,this.currentData)):this.vs.rowHeightService=new ee.RowHeightService(e,t,l);const d=this.vs.rowHeightService.totalHeight();this.vs.containerHeight=b.firefox?Math.min(b.firefoxMaxHeight,d):d}},onSkipChanged(e,t){Math.max(0,this.vs.attendedSkip)!==e&&e!==void 0&&(this.vs.attendedSkip=e,this.vs.propsSkip=(e||0)+(this.$props.scrollable==="virtual"?this.vs.topCacheCount+(this.vs.attendedSkip-(e||0)):0))},onTotalChanged(e,t){const i=this.currentGroupable;this.vs.reset(),this.vs=new q.VirtualScroll(i||this.$props.rowHeight===void 0||this.$props.rowHeight===0,this.$props.topCacheCount),this.resetVirtual(),this.setRefs()},onRowHeightChanged(e,t){const i=this.currentGroupable;this.vs.reset(),this.vs=new q.VirtualScroll(i||this.$props.rowHeight===void 0||this.$props.rowHeight===0,this.$props.topCacheCount),this.resetVirtual(),this.setRefs()},scrollHandler(e){clearTimeout(this.forceUpdateTimeout),this.$props.columnVirtualization&&!this.vs.scrollableVirtual&&(this.forceUpdateTimeout=setTimeout(()=>{this.$forceUpdate()},0)),this._header&&this._header.setScrollLeft(e.currentTarget.scrollLeft),this._footer&&this._footer.setScrollLeft(e.currentTarget.scrollLeft),this.vs&&this.vs.scrollHandler(e),this.$emit("scroll",e)},rowClick(e,t){e.target.type!=="checkbox"&&this.$emit("rowclick",{dataItem:t.dataItem,...this.getArguments(e)})},rowDoubleClick(e,t){e.target.type!=="checkbox"&&this.$emit("rowdblclick",{dataItem:t.dataItem,...this.getArguments(e)})},loopGroupedItems(e,t,i=0,a=null){return e.forEach(l=>{!a&&t(l,i)&&(a=l),l.items&&l.items.length&&!a&&(a=this.loopGroupedItems(l.items,t,i+1,a))}),a},updateGroupCollapsed(e){let t=this.computedCollapsed,i=t[e.level];const a=this.$props.uniqueField,l=function(p,C){return p.value===e.dataItem.value&&C===e.level},d=this.allGroupedItems?this.loopGroupedItems(this.allGroupedItems.data,l,0,null):e.dataItem,f=b.groupedFirstItemValue(d||e.dataItem,a);if(e.value){if(i&&i.length){const p=i.indexOf(f);p>-1&&i.splice(p,1)}}else i?i.includes(f)||i.push(f):i=[f];return t},itemChange(e){const t=o.hasListener.call(this,"itemchange");if(e.field===this.$props.expandField||(this.$props.group||this.$props.detail)&&e.field===void 0){o.hasListener.call(this,"expandchange")&&e.dataItem&&this.$emit("expandchange",{...this.getArguments(e.event),collapsedGroups:this.updateGroupCollapsed(e),dataItem:e.dataItem,value:e.value});return}t&&this.$emit("itemchange",{...this.getArguments(e.event),dataItem:e.dataItem,field:e.field,value:e.value})},cellClickHandler(e){this.$emit("cellclick",{dataItem:e.dataItem,field:e.field})},cellKeydownHandler(e){this.$emit("cellkeydown",e)},editHandler(e){this.$emit("edit",{dataItem:e})},removeHandler(e){this.$emit("remove",{dataItem:e})},saveHandler(e){this.$emit("save",{dataItem:e})},cancelHandler(e){this.$emit("cancel",{dataItem:e})},selectionChangeHandler(e){const{event:t,dataItem:i,dataIndex:a,columnIndex:l}=e;this.$emit("selectionchange",{...this.getArguments(t.event),dataItem:i,startColIndex:l,endColIndex:l,startRowIndex:a,endRowIndex:a,dataItems:this.getLeafDataItems(),altKey:!1,ctrlKey:!1,shiftKey:!1,metaKey:!1,isDrag:!1,componentId:this._gridId,selectedField:this.$props.selectedField||""})},onHeaderSelectionChangeHandler(e){this.$emit("headerselectionchange",{field:e.field,event:e.event,target:this})},pageChangeHandler(e,t){this.raiseDataEvent("pagechange",{page:e,event:t},{skip:e.skip,take:e.take},t)},sortChangeHandler(e,t){this.raiseDataEvent("sortchange",{sort:e},{sort:e},t)},filterChangeHandler(e,t){this.raiseDataEvent("filterchange",{filter:e},{filter:e,skip:0},t)},groupChangeHandler(e,t){this.raiseDataEvent("groupchange",{group:e},{group:e,skip:0},t)},raiseDataEvent(e,t,i,a){o.hasListener.call(this,e)?this.$emit(e,{...this.getArguments(a),...t}):o.hasListener.call(this,"datastatechange")&&this.$emit("datastatechange",{...this.getArguments(a),data:{...this.getDataState(),...i}})},columnReorder(e,t,i){const a=this._columns[e].depth,l=p=>{do p++;while(p<this._columns.length&&this._columns[p].depth>a);return p},d=this._columns.splice(e,l(e)-e);this._columns.splice(e<t?l(t-d.length):t,0,...d),this._columns.filter(p=>p.declarationIndex>=0).forEach((p,C)=>p.orderIndex=C);const f=this.getColumns();this.$emit("columnreorder",{target:this,columns:f,event:i,prev:e,next:t})},groupReorder(e,t,i){if(this.$props.group===void 0)return;const a=this.$props.group.slice();a.splice(t,0,...a.splice(e,1)),this.groupChangeHandler(a,i)},columnToGroup(e,t,i){const a=this._columns[e].field;if(!a)return;const l=(this.$props.group||[]).slice();l.splice(t,0,{field:a}),this.groupChangeHandler(l,i)},resetTableWidth(){let e=0;if(!this.columnResize.colGroupMain)return;const t=this.columnResize.colGroupMain.children;for(let i=0;i<t.length;i++){const a=t[i].width;if(!a)return;e+=parseFloat(a.toString())}e=Math.round(e),this._header&&this._header.setWidth(e),this._footer&&this._footer.setWidth(e),this.vs.table&&(this.vs.table.style.width=e+"px")},onResize(e,t,i,a,l){this.resetTableWidth(),this.$emit("columnresize",{columns:this.getColumns(),index:e,event:a,newWidth:t,oldWidth:i,end:l,target:this})},initColumns(e,t){const i=g.tableKeyboardNavigationTools.getIdPrefix(this.navigation);if(this._columns=b.readColumns(e,this.getColumns(),{prevId:0,idPrefix:i}),this._columns.length===0){const d=b.autoGenerateColumns(this.$props.dataItems,this.$props.group,this.$props.expandField,{prevId:0,idPrefix:i});this._columns=d}this.$props.selectedField&&this._columns.filter(d=>d.field===this.$props.selectedField).forEach(d=>{d.width=d.width||"50px",d.internalCell=r.markRaw(me.GridSelectionCell),d.internalHeaderCell=r.markRaw(_e.GridHeaderSelectionCell)});const a={id:"",resizable:!0,width:"32px",title:" ",declarationIndex:-1,orderIndex:-1,children:[],parentIndex:-1,depth:0,colSpan:0,rowSpan:0,left:0,right:0,index:0,rightBorder:!1,ariaColumnIndex:1,isAccessible:!0};let l=0;this.$props.expandField&&o.hasListener.call(this,"expandchange")&&this.$props.detail&&(this._columns.unshift({...a,internalCell:r.markRaw(be.GridHierarchyCell),field:this.$props.expandField,headerClassName:"k-hierarchy-cell k-header",id:g.tableKeyboardNavigationTools.generateNavigatableId(`${this._columns.length}`,i,"column"),...this.expandColumn}),l++);for(let d=0;d<t;d++)this._columns.unshift({...a,isAccessible:!1,internalCell:r.markRaw(te.GridGroupCell),field:"value"}),l++;this._columns.slice(l).forEach(d=>d.parentIndex>=0&&(d.parentIndex+=l)),this._columnsMap=b.mapColumns(this._columns),this.columnResize.columns=this._columns,this.dragLogic.columns=this._columns},resolveTitle(e){const t=this.findColumnByField(e),i=t&&(t.title||t.field);return i===void 0?e:i},findColumnByField(e){let t;return this.$props.columns.forEach(i=>{const a=this.searchColumn(i,e);a&&(t=a)}),t},searchColumn(e,t){if(e.field===t)return e;if(e.children){let i,a=null;for(i=0;a==null&&i<e.children.length;i++)a=this.searchColumn(e.children[i],t);return a}return null},getDataState(){return{filter:this.$props.filter,sort:this.$props.sort,skip:this.$props.skip,take:this.$props.take!==void 0?this.$props.take:this.$props.pageSize,group:this.$props.group}},getArguments(e){return{event:e,target:this}},getLeafDataItems(){return this.currentData.filter(e=>e.rowType==="data").map(e=>e.dataItem)},totalGroupedRows(e){let t=0;return e&&(t=this.addSubItems(e,t)),t},addSubItems(e,t){return e.forEach(i=>{t++,i.expanded!==!1&&i.items&&(t=this.addSubItems(i.items,t)),this.group&&this.group.length&&(this.$props.groupable.footer==="always"||i.expanded!==!1&&i.items&&this.$props.groupable.footer==="visible")&&t++}),t}},setup(){const e=r.ref(null),t=r.ref(null),i=r.ref(null),a=r.ref(null),l=r.ref(null),d=r.ref(null),f=r.ref(null),p=r.ref(null),C=r.ref(null),w=r.ref(null);return{groupPanelDivRef:e,dropElementClueRef:t,dragElementClueRef:i,headerRef:a,footerRef:l,gridNavRef:d,colGroupRef:f,scrollContainerRef:p,scrollTableRef:C,scrollTableBodyRef:w}},render(){const e=o.getDefaultSlots(this);let t=this.$props.total||0;const i=g.tableKeyboardNavigationTools.getIdPrefix(this.navigation);let a=[];Array.isArray(this.$props.dataItems)?a=this.$props.dataItems:this.$props.dataItems&&(a=b.applyExpandedState(this.$props.dataItems,this.$props.collapsedGroups.length?this.computedCollapsed:[],this.$props.uniqueField).data,t=t||this.$props.dataItems.total);const l=this.$props.groupable===!0||o.isObject(this.$props.groupable)&&this.$props.groupable.enabled!==!1;this.columnResize.resizable=this.$props.resizable||!1,this.dragLogic.reorderable=this.$props.reorderable||!1,this.dragLogic.groupable=l,this.initializeVirtualization(t);const d=o.isObject(this.$props.groupable)&&this.$props.groupable.footer||"none";this.currentData=[];const f=b.flatData(this.currentData,a,d,{index:this.$props.skip||0},this.$props.group!==void 0,this.$props.expandField),p=e||[];this.notHiddenColumns=this.filterHiddenColumns(this.$props.columns),this.initColumns(this.notHiddenColumns,f);const C=p.filter(s=>s&&s.tag&&s.tag.toLowerCase().indexOf("toolbar")!==-1||s.componentOptions&&s.componentOptions.tag&&s.componentOptions.tag.toLowerCase().indexOf("toolbar")!==-1||s.type&&s.type.name&&s.type.name.toLowerCase().indexOf("toolbar")!==-1),w=p.filter(s=>s&&s.tag&&s.tag.toLowerCase().indexOf("records")!==-1||s.componentOptions&&s.componentOptions.tag&&s.componentOptions.tag.toLowerCase().indexOf("records")!==-1||s.type&&s.type.name&&s.type.name.toLowerCase().indexOf("records")!==-1),y=this._columns.filter(s=>s.children.length===0),k=l&&r.createVNode(ye.GroupPanel,{ref:s=>{this.groupPanelDivRef=s},group:this.$props.group||[],ariaControls:this._gridRoleElementId,onGroupChange:this.groupChangeHandler,onPressHandler:this.dragLogic.pressHandler,onDragHandler:this.dragLogic.dragHandler,onReleaseHandler:this.dragLogic.releaseHandler,resolveTitle:this.resolveTitle},null),H=(this.dragLogic.reorderable||this.dragLogic.groupable)&&o.canUseDOM&&document&&document.body,A=[H&&r.createVNode(Ve.DropClue,{ref:s=>{this.dropElementClueRef=s}},null),H&&r.createVNode(Ne.DragClue,{ref:s=>{this.dragElementClueRef=s}},null)],P=r.createVNode(Ie.Header,{size:this.$props.size,columnResize:this.columnResize,staticHeaders:this.$props.scrollable!=="none",ref:s=>{this.headerRef=s},headerRow:r.createVNode(Re.HeaderRow,{grid:this,sort:this.$props.sort,groupable:this.$props.groupable,reorderable:this.$props.reorderable,sortable:this.$props.sortable,onSortChange:this.sortChangeHandler,filter:this.$props.filter,filterable:this.$props.filterable,filterOperators:this.$props.filterOperators||Z.operators,onFilterChange:this.filterChangeHandler,columnMenu:this.$props.columnMenu,columnMenuIcon:this.$props.columnMenuIcon,columnMenuAnimate:this.$props.columnMenuAnimate,onSelectionchange:this.onHeaderSelectionChangeHandler,columns:this._columns,columnsInitial:this.$props.columns,columnResize:this.columnResize,onPressHandler:this.dragLogic.pressHandler,onDragHandler:this.dragLogic.dragHandler,onReleaseHandler:this.dragLogic.releaseHandler,columnsMap:this._columnsMap,cellRender:this.$props.headerCellRender,isRtl:this.isRtl,isColCountDefined:this.getAriaColCount!==void 0,filterRow:this.$props.filterable&&r.createVNode(we.FilterRow,{grid:this,size:this.$props.size,columns:this._columns,filter:this.$props.filter,filterOperators:this.$props.filterOperators||Z.operators,onFilterchange:this.filterChangeHandler,sort:this.$props.sort,cellRender:this.$props.filterCellRender,isRtl:this.isRtl,ariaRowIndex:this._columnsMap.length+1},null)||void 0},null),cols:y.map(function(s,h){return r.createVNode("col",{key:h.toString(),width:s.width!==void 0?Math.floor(parseFloat(s.width.toString()))+"px":void 0},null)},this)},null),B=this._columns.some(s=>!!s.footerCell)?r.createVNode(ke.Footer,{size:this.$props.size,columnResize:this.columnResize,staticHeaders:this.$props.scrollable!=="none",ref:s=>{this.footerRef=s},row:r.createVNode(He.FooterRow,{isRtl:this.isRtl,rowIndex:this.getAriaRowCount+1,columns:this._columns.map(function(s){return{...s,footerCell:o.templateRendering.call(this,s.footerCell,o.getListeners.call(this))}},this)},null),cols:y.map(function(s,h){return r.createVNode("col",{key:h.toString(),width:s.width!==void 0?Math.floor(parseFloat(s.width.toString()))+"px":void 0},null)},this)},null):r.createVNode("span",null,null),_=o.templateRendering.call(this,this.$props.cellRender,o.getListeners.call(this)),re=this.showLicenseWatermark?r.createVNode(o.WatermarkOverlay,null,null):null,T=this.$attrs.style,oe=T&&o.isObject(T)&&T["width"]||"",ae=parseFloat(oe.toString()),le=this.vs&&this.vs.container&&this.vs.container.scrollLeft||0,{colSpans:z,hiddenColumns:ne}=g.tableColumnsVirtualization({enabled:this.$props.columnVirtualization,columns:this._columns,tableViewPortWidth:ae,scrollLeft:le}),D=function(s,h,$){let S=!1;const I=this.$props.selectedField,v=I?o.getNestedValue(I,s.dataItem):void 0;return{row:this._columns.map(function(n,c){if(ne[c])return null;const R=`${n.className?n.className+" ":""}${n.locked?"k-grid-content-sticky":""}`,x=n.left!==void 0?this.isRtl?{left:n.right+"px",right:n.left+"px"}:{left:n.left+"px",right:n.right+"px"}:{};let G=!1;if(n.editable&&this.$props.editField){const u=o.getNestedValue(this.$props.editField,s.dataItem);(u===!0||u===n.field)&&(S=!0,G=!0)}let m;n.cell&&(m=o.templateRendering.call(this,n.cell,o.getListeners.call(this)));const F=this.computedCollapsed&&this.computedCollapsed[s.level]&&this.computedCollapsed[s.level].some(u=>u===b.groupedFirstItemValue(s.dataItem,this.$props.uniqueField)),E=F?!F:s.expanded;return n.internalCell?r.createVNode(n.internalCell,{key:c,id:g.tableKeyboardNavigationTools.generateNavigatableId(`${h}-${String(c)}`,i),colSpan:z[c],dataItem:s.dataItem,field:n.field||"",editor:n.editor,format:n.format,readFormat:n.readFormat,type:n.type,className:R,render:m||_,onChange:this.itemChange,onSelectionchange:u=>this.selectionChangeHandler({event:u,dataItem:s.dataItem,dataIndex:$,columnIndex:c}),columnIndex:c,columnsCount:this._columns.filter(u=>!u.children.length).length,rowType:s.rowType,level:s.level,expanded:E,dataIndex:s.dataIndex,style:x,ariaColumnIndex:n.ariaColumnIndex,isRtl:this.isRtl,isSelected:Array.isArray(v)&&v.indexOf(c)>-1},null):G?r.createVNode(ve.GridEditCell,{id:g.tableKeyboardNavigationTools.generateNavigatableId(`${h}-${String(c)}`,i),key:c,colSpan:z[c],dataItem:s.dataItem,field:n.field||"",editor:n.editor,format:n.format,readFormat:n.readFormat,type:n.type,className:R,render:m||_,onEdit:this.editHandler,onRemove:this.removeHandler,onSave:this.saveHandler,onCancel:this.cancelHandler,onChange:this.itemChange,columnIndex:c,columnsCount:this._columns.filter(u=>!u.children.length).length,rowType:s.rowType,level:s.level,expanded:E,dataIndex:s.dataIndex,style:x},null):r.createVNode(Ge.GridCell,{key:c,id:g.tableKeyboardNavigationTools.generateNavigatableId(`${h}-${String(c)}`,i),colSpan:z[c],dataItem:s.dataItem,field:n.field||"",editor:n.editor,format:n.format,readFormat:n.readFormat,type:n.type,className:R,render:m||_,onCellclick:this.cellClickHandler,onCellkeydown:this.cellKeydownHandler,onEdit:this.editHandler,onRemove:this.removeHandler,onSave:this.saveHandler,onCancel:this.cancelHandler,onChange:this.itemChange,onSelectionchange:u=>this.selectionChangeHandler({event:u,dataItem:s.dataItem,dataIndex:$,columnIndex:c}),columnIndex:c,columnsCount:this._columns.filter(u=>!u.children.length).length,rowType:s.rowType,level:s.level,expanded:E,dataIndex:s.dataIndex,style:x},null)},this),isInEdit:S,isSelected:typeof v=="boolean"&&v}};let j=0;if(this.$props.scrollable==="virtual"&&this.totalGroupedRows(this.currentData)/2>this.$props.take){const s=this.vs.topCacheCount+this.vs.attendedSkip-(this.$props.skip||0);for(let h=0;h<s;){const $=this.currentData.shift();if($)this.currentData.push($),j++,$.rowType==="groupHeader"&&h--;else break;h++}}const K=s=>s>=this.currentData.length-j,de=o.templateRendering.call(this,this.$props.detail,o.getListeners.call(this));let L=this.vs.propsSkip||0;const N=this._columnsMap.length+(this.$props.filterable?1:0)+1;let V,O=-1,M=0;const W=this.currentData.length&&this.currentData.map(function(s,h){s.rowType==="data"&&(L++,O++),this.$props.alternatePerGroup&&s.rowType==="groupHeader"&&(L=0);const $=L%2===0,S=this.$props.dataItemKey&&o.getter(this.$props.dataItemKey)(s.dataItem),I=h+(this.vs.propsSkip||0),v=S||"ai"+I,n=v+"_1";V=I+N+M;const c=o.templateRendering.call(this,this.$props.rowRender,o.getListeners.call(this));let R;this.$props.detail&&s.rowType==="data"&&s.expanded&&(R=y.length-(this.$props.expandField?1:0)-(this.$props.group?this.$props.group.length:0)||1,M++,V=I+N+M);const x=h*2+N,G=h*2+N+1;return[r.createVNode(Fe.GridRow,{key:v,dataItem:s.dataItem,isAltRow:$,isInEdit:D.isInEdit,isSelected:D.isSelected,rowType:s.rowType,isHidden:K(h),onRowclick:m=>this.rowClick(m,s),onRowdblclick:m=>this.rowDoubleClick(m,s),selectedField:this.$props.selectedField,rowHeight:this.$props.rowHeight,render:c,ariaRowIndex:this.$props.detail?x:V,dataIndex:O,class:this.$props.rowClass?this.$props.rowClass(s):""},{default:()=>[D.call(this,s,v,O).row]}),this.$props.detail&&s.rowType==="data"&&s.expanded&&r.createVNode("tr",{key:n,class:$?"k-table-row k-table-alt-row k-detail-row k-alt":"k-table-row k-detail-row",style:{visibility:K(h)?"hidden":"",height:this.$props.detailRowHeight+"px"},role:"row","aria-rowindex":this.$props.detail?G:V},[this.$props.group&&this.$props.group.map(function(m,F){return r.createVNode(te.GridGroupCell,{id:"",dataIndex:s.dataIndex,field:m.field,dataItem:s.dataItem,key:F},null)},this),this.$props.expandField&&r.createVNode(Ce.GridDetailHierarchyCell,{id:g.tableKeyboardNavigationTools.generateNavigatableId(`${n}-dhcell`,i)},null),r.createVNode($e.GridDetailCell,{dataItem:s.dataItem,dataIndex:s.dataIndex,colSpan:R,ariaColIndex:2+(this.$props.group?this.$props.group.length:0),detail:this.$props.detail?de:void 0,id:g.tableKeyboardNavigationTools.generateNavigatableId(`${n}-dcell`,i)},null)])]},this)||r.createVNode("tr",{class:"k-table-row k-grid-norecords"},[r.createVNode("td",{class:"k-table-td",colspan:this._columns.filter(s=>!s.children.length).length},[w.length?w:r.createVNode(Te.GridNoRecords,null,null)])]),he=o.templateRendering.call(this,this.$props.pager,o.getListeners.call(this)),pe=this.$props.pageable&&r.createVNode(g.Pager,{class:"k-grid-pager",onPagesizechange:this.pageChangeHandler,onPagechange:this.pageChangeHandler,size:this.$props.size,total:t,skip:this.vs.propsSkip||0,pageSize:(this.$props.take!==void 0?this.$props.take:this.$props.pageSize)||10,messagesMap:ie.pagerMessagesMap,settings:g.normalize(this.$props.pageable||{})},null),U=o.getTemplate.call(this,{h:r.h,template:he,defaultRendering:pe,additionalProps:{...this.$props,skip:this.vs.propsSkip||0,messagesMap:ie.pagerMessagesMap},additionalListeners:{pagesizechange:this.pageChangeHandler,pagechange:this.pageChangeHandler}}),ce=s=>this.$props.sort&&this.$props.sort.filter(h=>h.field===s).length>0,J=r.createVNode("colgroup",{ref:o.setRef(this,"colGroup")},[y.map(function(s,h){return r.createVNode("col",{key:h.toString(),class:ce(s.field)?"k-sorted":void 0,width:s.width!==void 0?s.width.toString().indexOf("%")!==-1?s.width:Math.floor(parseFloat(s.width.toString()))+"px":void 0},null)},this)]),Q={height:this.getCorrectHeight},ue=o.templateRendering.call(this,this.$props.loader,o.getListeners.call(this)),ge=this.$props.loader&&r.createVNode("div",{class:"k-loader-container k-loader-container-md k-loader-top"},[r.createVNode("div",{class:"k-loader-container-overlay k-overlay-light"},null),r.createVNode("div",{class:"k-loader-container-inner"},[r.createVNode(fe.Loader,{size:"large",type:"infinite-spinner"},null)])]),X=o.getTemplate.call(this,{h:r.h,template:ue,defaultRendering:ge});return this.$props.scrollable==="none"?r.createVNode(g.TableKeyboardNavigationProvider,{ref:"navRef",id:this._gridId,navigatable:this.$props.navigatable},{default:()=>[r.createVNode(Y.GridNav,{ref:s=>{this.gridNavRef=s},currentData:this.currentData,style:Q,class:this.nonscrollableWrapperClass},{default:()=>[C,k,r.createVNode("div",{role:"grid",class:"k-grid-aria-root",id:this._gridRoleElementId,"aria-colcount":this.getAriaColCount,"aria-rowcount":this.getAriaRowCount},[r.createVNode("table",{class:"k-table",style:{tableLayout:"fixed"},role:"none"},[J,P,r.createVNode("tbody",{class:"k-table-tbody","data-keyboardnavbody":!0},[W,X]),B])]),U,A]})]}):r.createVNode(g.TableKeyboardNavigationProvider,{ref:"navRef",id:this._gridId,navigatable:this.$props.navigatable},{default:()=>[r.createVNode(Y.GridNav,{ref:s=>{this.gridNavRef=s},currentData:this.currentData,style:Q,class:this.scrollableWrapperClass},{default:()=>[C,k,r.createVNode("div",{role:"grid",class:"k-grid-aria-root",id:this._gridRoleElementId,"aria-colcount":this.getAriaColCount,"aria-rowcount":this.getAriaRowCount},[P,r.createVNode("div",{class:"k-grid-container",role:"presentation"},[r.createVNode("div",{role:"presentation",ref:o.setRef(this,"scrollContainer"),class:"k-grid-content k-virtual-content",onScroll:this.scrollHandler},[r.createVNode("div",{class:"k-grid-table-wrap",role:"presentation"},[r.createVNode("table",{role:"none",class:this.gridTableClass,ref:o.setRef(this,"scrollTable")},[J,r.createVNode("tbody",{class:"k-table-tbody",role:"rowgroup","data-keyboardnavbody":!0,ref:o.setRef(this,"scrollTableBody")},[W])])]),r.createVNode("div",{class:"k-height-container",role:"presentation"},[r.createVNode("div",{style:this.$props.scrollable==="virtual"?{height:this.vs.containerHeight+"px"}:{}},null)])]),X]),B,re]),U,A]})]})}});exports.Grid=ze;
